/**
  ******************************************************************************
  * @file           : main.c
  * @author         : SINOMCU-AE
  * @brief          : Main program body
  *    
  *          This file provides example code for Timer basic and printf by uart.
  * LED1 Toggle by Timer UIF interrupt;uart send information of running count
  * (redirect printf),defualt period 0.5s.
  * For details, see "readme.txt"    
  *         
  ******************************************************************************
   * @attention 
  *                           DISCLAIMER
  * The present firmware which is for guidance only aims at providing customers
  * with coding information regarding their products in order for them to save
  * time. As a result, SinoMCU shall not be held liable for any direct,indirect
  * or consequential damages with respect to any claims arising from the content 
  * of such firmware and/or the use made by customers of the coding information 
  * contained herein in connection with their products.
  *
  * <h2><center>&copy; Copyright (c) 2021 sinomcu All rights reserved.</center></h2>
  *
  ******************************************************************************
  */  
  
#include "system_define.h"

#define COUNT_PERIOD    500       // unit ms

FlagStatus USER_TIMER_BASIC_UIF = RESET;

/**
  * @brief  Main program
  * @param  None
  * @retval None
  */
int main(void) 
{
  uint32_t count=0;
    
  //SystemClock_Config();           // sysclk 48M,HSI 8M /2*12;if not call this function,default HSI 8M
  SystemCoreClockUpdate();        // get System Core Clock
    
  SysTick_Init();
  GPIO_Init();
  Timer_Basic_Init();
  
#if(defined(EN_PRINT_UART) && EN_PRINT_UART)   
  MS32_RCC_SetUSARTClockSource(MS32_RCC_USART1_CLKSOURCE_HSI);       // uart clk HSI 8M  
  USART1_UART_Init(115200);
#endif
  LED1_ON(); 
  
  printf("\r\n\r\n*****Timer Basic LED Toggle Example*****");
  printf("\r\n--Inf:System Core Clock %d Hz.",SystemCoreClock);
    
  Start_User_MS_SF_Timer(COUNT_PERIOD);
  while(1) 
  {
    if(USER_TIMER_BASIC_UIF == SET)                                  // Timer UIF interrupt
    {
      USER_TIMER_BASIC_UIF = RESET;  
      LED1_TOGGLE();
#if( defined(USER_TIMER1) && USER_TIMER1)
      printf("\r\n--Inf:Timer1 Basic UIF Set");
#endif
#if( defined(USER_TIMER2) && USER_TIMER2)
      printf("\r\n--Inf:Timer2 Basic UIF Set");
#endif
    }    
    
    if(Get_State_User_MS_SF_Timer() == SF_TIMER_OV)
    {
      Start_User_MS_SF_Timer(COUNT_PERIOD);                          // clear soft timer ov
      count++;
      printf("\r\n--Inf: running count:%d",count);
    }
  }
}

/**
  * @brief  timer UIF interrupt callback function
  * @param  None
  * @retval None
  */
void Timer_Basic_Callback(void)
{
  USER_TIMER_BASIC_UIF = SET;
}

/**
  * @brief  SystemClock_Config PLL 48M
  * @param  None
  * @retval None
  */
void SystemClock_Config(void)
{
  MS32_FLASH_SetLatency(MS32_FLASH_LATENCY_1);
  while(MS32_FLASH_GetLatency() != MS32_FLASH_LATENCY_1){ ; }
  MS32_RCC_HSI_Enable();

  // Wait HSI is ready
  while(MS32_RCC_HSI_IsReady() != 1){ ; }
 
  MS32_RCC_PLL_ConfigDomain_SYS(MS32_RCC_PLLSOURCE_HSI_DIV_2, MS32_RCC_PLL_MUL_12);
  MS32_RCC_PLL_Enable();

  // Wait PLL is ready 
  while(MS32_RCC_PLL_IsReady() != 1){ ; }

  MS32_RCC_SetAHBPrescaler(MS32_RCC_SYSCLK_DIV_1);
  MS32_RCC_SetAPB1Prescaler(MS32_RCC_APB1_DIV_1);
  MS32_RCC_SetSysClkSource(MS32_RCC_SYS_CLKSOURCE_PLL);

  // Wait System clock is ready
  while(MS32_RCC_GetSysClkSource() != MS32_RCC_SYS_CLKSOURCE_STATUS_PLL){ ; }
}

/******************************** END OF FILE *********************************/
